#############################################
#   IMPORT LIBRARIES
#############################################
import serial
import operator
import os
import time
import string

test = "off"

say = "python /home/srs/apps/tel/speak "

#############################################
#   CONFIGURE SERIAL PORTS



#############################################
#   SUBROUTINES AND FUNCTIONS
#############################################

def welcome():
    print "=" * 33
    print "STARTING COMMAND PROCESSOR"
    print "=" * 33
def print_break(title):
    x = len(title)
    width = 40
    stars = (width-x-4) /2
    print "*" * stars + "  " + title.upper() + "  " + "*" * stars
#-------------------------------------------------------------------------------------

# The basic concept of this program structure is to create a dictionary with
# keys that are the strings coming from the controller, and values which
# are objects which can print themselves and carry out an action.
# These two operations are the methods, prnt() and act()
# The prnt() method is design to print something to standard output
# The act() method does different things depending on the type of
# object.  For most of them, it commands the Beaglebone to speak.

# This is implemented by defining a general purpose object class which
# is initialized with two strings, one to print to the screen, and one
# to pass to the operating system to execute as if it were typed into a
# command shell.

# The notion of object inheritance is used to define more specific object
# classes to perform different kinds of actions, without having the specify
# the entire command string when defining each specific object.
# For example, the Lnkcmd object class, just take the link number and 
# "on" or "off", and puts together the more complete strings to be printed
# and sent to the operating system when it is constructed.

# In this manner, the same dictionary and program structure can 



class Cmd(object):
  def __init__(self,printstring,actionstring):
    self.pstring = printstring
    self.astring = actionstring
	
  def prnt(self):
    print("Execute command - " + self.pstring);
	
  def act(self):
    if test=="on":
      os.system("echo "+"\""+self.astring+"\"")
    else:
      os.system(self.astring)
    return 0
	
class Saycmd(Cmd):
  def __init__(self,printstring,actionstring):
    Cmd.__init__(self,printstring, say+actionstring)
	
	
class Lnkcmd(Saycmd):
  def __init__(self,linkno,onoff):
    Saycmd.__init__(self,"Link "+linkno+" "+onoff,"link "+linkno+" "+onoff)


class Appcmd(Cmd):
  def __init__(self, printstring, cmd):
    Cmd.__init__(self,printstring, "sh /home/srs/apps/"+cmd)

class Nullcmd(Cmd):
  def act(self):
    return 0
    
class Exitcmd(Cmd):
  def act(self):
    return 1
  
	
		
cmddict = {
  "L1ON" : Lnkcmd("1","on"),
  "L1OFF" : Lnkcmd("1","off"),
  "L2ON" : Lnkcmd("2","on"),
  "L2OFF" : Lnkcmd("2","off"),
  "L3ON" : Lnkcmd("3","on"),
  "L3OFF" : Lnkcmd("3","off"),
  "L4ON" : Lnkcmd("4","on"),
  "L4OFF" : Lnkcmd("4","off"),
  "L5ON" : Lnkcmd("5","on"),
  "L5OFF" : Lnkcmd("5","off"),
  "L6ON" : Lnkcmd("6","on"),
  "L6OFF" : Lnkcmd("6","off"),
  "L7ON" : Lnkcmd("7","on"),
  "L7OFF" : Lnkcmd("7","off"),
  "LMON" : Saycmd("Execute command - Link Monitor","link monitor"),
  "MMUTE" : Saycmd("Execute command - Link Mute","monitor mute"),
  "MMIX" : Saycmd("Execute command - Monitor Mix","monitor mix"),
  "LINKNORMAL" : Saycmd("Execute command - Link normal", "link normal"),
  "SN" : Saycmd("Execute command - Site normal", "site normal"),
  "RBTXEN" : Saycmd("Execute command - Remote Base TX enable", "transmit enable"),
  "RBOFF" : Saycmd("Execute command - Remote base off", "remote base off"),
  "VID" : Saycmd("Execute command - Voice ID", "k j 6 v u"),
  "SID" : Saycmd("Execute command - Site ID", "portable repeater system"),
  "101" : Appcmd("Execute command 101", "cmd_101"),
  "102" : Appcmd("Execute command 102", "cmd_102"),
  "R011" : Appcmd("Execute command - Ry1 On", "dcn/ry_2_1_on"),
  "R010" : Appcmd("Execute command - Ry1 Off", "dcn/ry_2_1_off"),
  "RESET" : Nullcmd("***reset***",""),
  "TEST" : Nullcmd("TEST", ""),
  "EXIT" : Exitcmd("EXIT", "")
}


#############################################
#   MAIN PROGRAM START
#############################################

welcome()


if test=="on":
  f = open("test.txt",'r')
else:
  ser = serial.Serial('/dev/ttyO1', 9600)

#############################################
### MAIN CONTROL LOOP
while True:
  #for line in f:
  if test=="on": line = f.readline()
  if test=="off": line = ser.readline()
  if not line: break;
  incmd = string.upper(string.strip(line))
  print("Command: >"+incmd+"<")
  if incmd in cmddict:
    cmdobj = cmddict[incmd]
    cmdobj.prnt()
    if 1==cmdobj.act(): break
f.close()
