#############################################
#   IMPORT LIBRARIES
#############################################
import Adafruit_BBIO.GPIO as GPIO
#import serial
#import operator
#import os
#import time
#import sys

#############################################
#   CONFIGURE SERIAL PORTS
#############################################

#############################################
#   DEFINE VARIABLES AND PHYSICAL PIN MAPPING
cor	  = "GPIO2_1"
pl	  = "GPIO0_26"
ptt	  = "GPIO1_14"
mute	  = "GPIO1_13"
netreset  = "GPIO1_15"
rfreset	  = "GPIO0_27"
red_led	  = "GPIO1_12"
green_led = "GPIO1_29"

#############################################
#   SUBROUTINES AND FUNCTIONS
#############################################

def welcome():
    print "=" * 33
    print "TELEMETRY SYSTEM - SPEAK PHRASE"
    print "=" * 33
def print_break(title):
    x = len(title)
    width = 40
    stars = (width-x-4) /2
    print "*" * stars + "  " + title.upper() + "  " + "*" * stars
def keyup():
    GPIO.output	(red_led,  GPIO.HIGH) 	# Turn on top red LED
    GPIO.output (cor,  GPIO.HIGH)	# COR active
    GPIO.output (pl, GPIO.HIGH)		# PL decode active
    GPIO.output (mute, GPIO.HIGH)	# Enable audio path
def unkey():
    GPIO.output (red_led,  GPIO.LOW)  	# Turn off top red LED
    GPIO.output (cor,  GPIO.LOW)	# COR inactive
    GPIO.output (pl, GPIO.LOW)		# PL decode inactive
    GPIO.output (mute, GPIO.LOW)	# Disable audio path
### System reset does not work right.  The netreset signal goes nowhere
### The RF reset is an input from the master CPU and needs to be changed here.
def system_reset():
    GPIO.output (rfreset, GPIO.HIGH)	# Pull bus reset signal low
    time.sleep (2)
    GPIO.output (rfreset, GPIO.LOW)	# Release bus reset


#############################################
#   GPIO IO PIN CONFIGURATION
#############################################
GPIO.setup  (cor,  GPIO.OUT)		# RCB COR input
GPIO.setup  (pl, GPIO.OUT)		# RCB PL input
GPIO.setup  (ptt, GPIO.IN)		# RCB PTT output
GPIO.setup  (mute, GPIO.OUT)		# Audio mute control
GPIO.setup  (netreset, GPIO.OUT)	# Net reset
GPIO.setup  (rfreset, GPIO.OUT)		# RF Xbee module reset
GPIO.setup  (red_led, GPIO.OUT)		# Upper LED (RED)
GPIO.setup  (green_led, GPIO.OUT)	# Lower LED (GREEN)

GPIO.output (cor,  GPIO.LOW)		# Default COR off
GPIO.output (pl, GPIO.LOW)		# Default PL  off
GPIO.output (mute, GPIO.HIGH)		# Default audio path enabled
GPIO.output (netreset, GPIO.LOW)	# Default Net reset high
GPIO.output (rfreset, GPIO.LOW)		# Default RF Xbee reset high
GPIO.output (red_led, GPIO.LOW)		# Default RED LED off
GPIO.output (green_led, GPIO.LOW)	# Default GREEN LED off

